unit genericf;  {generic functions unit - not rusnews-specific at all}

{ formerly from the file... }

{

rusn-fun.pas - rusnews functions

}

{

Russell Schulz - russell@alpha3.ersys.edmonton.ab.ca (940423)

Copyright 1994 Russell Schulz

this code is not in the Public Domain

permission is granted to use these routines in any application regardless
of commercial status as long as the author of these routines assumes no
liability for any damages whatsoever for any reason.  have fun.

}

{
version of this unit: 1
}

interface

uses dos;

function max(a,b: integer): integer;
function min(a,b: integer): integer;
function integertozstring(i, width: integer): string;
function longtozstring(l: longint; width: integer): string;
function time: string;
function timedigits: string;
function dow: integer;
function cdow: string;
function dayofmonth: integer;
function month: integer;
function extmonthname(themonth: integer): string;
function monthname: string;
function year: integer;
function getenv(s: string): string;
function numoccur(c: char; s: string): integer;
function unquote(s: string): string;
function crepl(s: string; cold, cnew: char): string;
function unslash(s: string): string;
function ununderscore(s: string): string;
function srepl(s: string; sold, snew: string): string;
function unspace(s: string): string;
function atow(s: string): word;
function atoi(s: string): integer;
function atol(s: string): longint;
function itoa(i: integer): string;
function ltoa(l: longint): string;
function lowcase(c: char): char;
function upper(s: string): string;
function lower(s: string): string;
function proper(s: string): string;
function ltrim(s: string): string;
function trim(s: string): string;
function right(s: string; i: integer): string;
function getfirstw(s: string): string;
function chopfirstw(var s: string): string;
function getquoted(s: string): string;
function randomletter: char;
function randomdigit: char;
function getfromaddr(from: string): string;
function getfromname(from: string): string;
function chop(s: string; i: integer): string;
function nore(s: string): string;
function monthstringtointeger(monthstr: string): integer;
function isdigit(c: char): boolean;
function islower(c: char): boolean;
function snatchint(var s: string): integer;
function getuniqfile(groupdir: string): string;
function getuniqfext(basename: string): string;
function expand(str: string): string;
function isdev(s: string): boolean;
function rot13(s: string): string;
function indir(filespec,dir: string): boolean;
function default(defaultstr,possiblyemptystr: string): string;
function rposc(s: string; c: char): integer;
function fexists(fn: string): boolean;
function withbackslash(s: string): string;
function nobeep(s: string): string;
function gettag(tag: string; s: string): string;

implementation

function max;

begin
  if a>b then max := a else max := b;
end;

function min;

begin
  min := -max(-a,-b);
end;

function integertozstring;

var
  result: string;

begin
  str(i,result);
  while length(result)<width do
    result := '0'+result;
  integertozstring := result;
end;

function longtozstring;

var
  result: string;

begin
  str(l,result);
  while length(result)<width do
    result := '0'+result;
  longtozstring := result;
end;

function time;

var
  h,m,s,s00: word;

begin
  gettime(h,m,s,s00);
  time := integertozstring(h,2)+':'+integertozstring(m,2)+':'+
   integertozstring(s,2);
end;

function timedigits;

var
  h,m,s,s00: word;

begin
  gettime(h,m,s,s00);
  timedigits :=
   integertozstring(h,2)+integertozstring(m,2)+integertozstring(s,2);
end;

function dow;

var
  y,m,d,realdow: word;

begin
  getdate(y,m,d,realdow);
  dow := realdow;
end;

function cdow;

var
  result: string;
  thedow: integer;

begin
  thedow := dow;
  result := 'Sunday';
  if thedow=1 then result := 'Monday';
  if thedow=2 then result := 'Tuesday';
  if thedow=3 then result := 'Wednesday';
  if thedow=4 then result := 'Thursday';
  if thedow=5 then result := 'Friday';
  if thedow=6 then result := 'Saturday';
  cdow := result;
end;

function dayofmonth;

var
  y,m,d,dow: word;

begin
  getdate(y,m,d,dow);
  dayofmonth := d;
end;

function month;

var
  y,m,d,dow: word;

begin
  getdate(y,m,d,dow);
  month := m;
end;

function extmonthname;

var
  result: string;

begin
  result := 'January';
  if themonth=2  then result := 'February';
  if themonth=3  then result := 'March';
  if themonth=4  then result := 'April';
  if themonth=5  then result := 'May';
  if themonth=6  then result := 'June';
  if themonth=7  then result := 'July';
  if themonth=8  then result := 'August';
  if themonth=9  then result := 'September';
  if themonth=10 then result := 'October';
  if themonth=11 then result := 'November';
  if themonth=12 then result := 'December';
  extmonthname := result;
end;

function monthname;

begin
  monthname := extmonthname(month);
end;

function year;

var
  y,m,d,dow: word;

begin
  getdate(y,m,d,dow);
  year := y;
end;

function getenv;

var
  i: integer;
  envseg: word;
  envread: integer;
  firstb: byte;
  thisb: byte;
  varname: string;
  vardata: string;
  done: boolean;
  result: string;

begin
  result := '';
  envseg := memw[prefixseg:$2c];
  envread := 0;
  repeat
    firstb := mem[envseg:envread];
    if firstb>0 then
      begin
        varname := '';
        repeat
          thisb := mem[envseg:envread];
          inc(envread);
          if thisb<>ord('=') then
            varname := varname+chr(thisb);
        until thisb=ord('=');
        vardata := '';
        repeat
          thisb := mem[envseg:envread];
          inc(envread);
          if thisb>0 then
            vardata := vardata+chr(thisb);
        until thisb=0;
        done := (varname=s);
        if done then
          result := vardata;
    end;
  until (firstb=0) or done;
  getenv := result;
end;

function numoccur;

var
  result: integer;
  i: integer;

begin
  result := 0;
  for i := 1 to length(s) do
    if s[i]=c then
      inc(result);
  numoccur := result;
end;

function unquote;

begin
  if (s[1]='"') and (s[length(s)]='"') then
    unquote := copy(s,2,length(s)-2)
  else
    unquote := s;
end;

function crepl;

var
  i: integer;
  result: string;

begin
  result := s;
  for i := 1 to length(result) do
    if result[i]=cold then
      result[i] := cnew;
  crepl := result;
end;

function unslash;

begin
  unslash := crepl(s,'/','\');
end;

function ununderscore;

begin
  ununderscore := crepl(s,'_',' ');
end;

function srepl;

var
  result: string;
  at: integer;

begin
  result := s;
  repeat
    at := pos(sold,result);
    if at<>0 then
      begin
        if sold=result then
          result := snew
        else if at=1 then
          result := snew+copy(result,length(sold)+1,255)
        else if at=length(result)-length(sold)+1 then
          result := copy(result,1,at-1)+snew
        else
          result := copy(result,1,at-1)+snew+copy(result,at+length(sold),255);
        if s=result then
          at := 0; {avoid infinite loops}
      end;
  until (at=0) or (length(result)=255);
  srepl := result;
end;

function unspace;

var
  i: integer;
  result: string;

begin
  if (numoccur(' ',s)=0) and (numoccur(^I,s)=0) then
    result := s
  else
    begin
      result := '';
      for i := 1 to length(s) do
        if (s[i]<>' ') and (s[i]<>^I) then
          result := result+s[i];
    end;
  unspace := result;
end;

function atow;

var
  result: word;
  code: word;

begin
  val(s,result,code);
  atow := result;
end;

function atoi;

var
  result: integer;
  code: word;

begin
  val(s,result,code);
  atoi := result;
end;

function atol;

var
  result: longint;
  code: word;

begin
  val(s,result,code);
  atol := result;
end;

function itoa;

begin
  itoa := integertozstring(i,0);
end;

function ltoa;

begin
  ltoa := longtozstring(l,0);
end;

function lowcase; {similar to the supplied upcase}

begin
  if (c>='A') and (c<='Z') then
    lowcase := chr(ord(c)-ord('A')+ord('a'))
  else
    lowcase := c;
end;

function upper;

var
  result: string;
  i: integer;

begin
  result := s;
  for i := 1 to length(s) do
    result[i] := upcase(result[i]);
  upper := result;
end;

function lower;

var
  result: string;
  i: integer;

begin
  result := s;
  for i := 1 to length(s) do
    result[i] := lowcase(result[i]);
  lower := result;
end;

function proper;

var
  result: string;
  i: integer;

begin
  result := s;
  if length(s)>0 then
    if (result[1]>='a') and (result[1]<='z') then
      result[1] := chr(ord(result[1])-ord('a')+ord('A'));
  for i := 2 to length(s) do
    if (result[i]>='A') and (result[i]<='Z') then
      result[i] := chr(ord(result[i])-ord('A')+ord('a'));
  proper := result;
end;

function ltrim;

var
  result: string;

begin
  result := s;
  while ((result[1]=' ') or (result[1]=^I)) and (length(result)>0) do
    result := copy(result,2,255);
  ltrim := result;
end;

function trim;

var
  result: string;

begin
  result := s;
  while ((result[length(result)]=' ') or (result[length(result)]=^I)) and
   (length(result)>0) do
    result := copy(result,1,length(result)-1);
  trim := result;
end;

function right;

begin
  right := copy(s,max(1,length(s)-i+1),i);
end;

function getfirstw;

var
  result: string;
  spaceat: integer;
  tabat: integer;

begin
  result := trim(ltrim(s));
  spaceat := pos(' ',result);
  tabat := pos(^I,result);
  if tabat>0 then
    if (spaceat>0) and (tabat>spaceat) then
      result := copy(result,1,spaceat-1)
    else
      result := copy(result,1,tabat-1)
  else
    if spaceat>0 then
      result := copy(result,1,spaceat-1);
  getfirstw := result;
end;

function chopfirstw;

var
  result: string;

begin
  s := trim(ltrim(s));
  result := getfirstw(s);
  s := trim(ltrim(copy(s,length(result)+1,255)));
  chopfirstw := result;
end;

function getquoted;

var
  result: string;

begin
  result := '';

  if copy(s,1,1)='"' then
    begin
      result := copy(s,2,255);
      if pos('"',result)=0 then
        result := getfirstw(result)
      else
        result := copy(result,1,pos('"',result)-1);
    end
  else
    result := getfirstw(s);

  getquoted := result;
end;

function randomletter;

begin
  if random(2)=0 then
    randomletter := chr(ord('a')+random(26))
  else
    randomletter := chr(ord('A')+random(26));
end;

function randomdigit;

begin
  randomdigit := chr(ord('0')+random(10));
end;

function getfromaddr;

var
  result: string;
  at: integer;

begin
  at := pos('<',from);
  if at>0 then {Full Name <address>}
    result := copy(from,at+1,length(from)-at-1)
  else
    begin
      at := pos(' ',from);
      if at>0 then {address (Full Name)}
        result := copy(from,1,at-1)
      else {address}
        result := from;
    end;
  getfromaddr := result;
end;

{be careful with address like

  "Some (Happy) User" <some@happy.com>

- need to grab the right parts right}

function getfromname;

var
  result: string;
  at: integer;

begin
  result := '';
  if copy(from,length(from),1)='>' then
    begin
      at := pos('<',from);
      if at>1 then
        result := copy(from,1,at-2);
    end;
  if result='' then
    begin
      at := pos('(',from);
      if at>0 then
        result := copy(from,at+1,length(from)-at-1)
      else
        begin
          at := pos('<',from);
          if at>1 then
            result := copy(from,1,at-2);
        end;
    end;
  getfromname := unquote(result);
end;

function chop;

var
  result: string;

begin
  chop := copy(s,i+1,255);
end;

function nore;

begin

{should always be 4 and 'Re: ', but uppercase and ltrim to deal with others}

  if upper(copy(s,1,3))='RE:' then
    nore := ltrim(chop(s,3))
  else
    nore := s;
end;

function monthstringtointeger;

var
  result: integer;
  lowermonthstr: string;

begin
  result := 12;
  lowermonthstr := lower(monthstr);
  if lowermonthstr='jan' then result := 1
  else if lowermonthstr='feb' then result := 2
  else if lowermonthstr='mar' then result := 3
  else if lowermonthstr='apr' then result := 4
  else if lowermonthstr='may' then result := 5
  else if lowermonthstr='jun' then result := 6
  else if lowermonthstr='jul' then result := 7
  else if lowermonthstr='aug' then result := 8
  else if lowermonthstr='sep' then result := 9
  else if lowermonthstr='oct' then result := 10
  else if lowermonthstr='nov' then result := 11;
  monthstringtointeger := result;
end;

function isdigit;

begin
  isdigit := (c>='0') and (c<='9');
end;

function islower;

begin
  islower := (c>='a') and (c<='z');
end;

function snatchint;

var
  intsofar: integer;

begin
  intsofar := 0;
  while (length(s)>0) and not isdigit(s[1]) do
    s := chop(s,1);
  while (length(s)>0) and isdigit(s[1]) do
    begin
      intsofar := 10*intsofar+ord(s[1])-ord('0');
      s := chop(s,1);
    end;
  snatchint := intsofar;
end;

function getuniqfile;

var
  result: integer;
  fileinfo: searchrec;

begin
  result := 0;
  findfirst(groupdir+'\'+'*',archive,fileinfo);
  while doserror=0 do
    begin
      result := max(result,atoi(fileinfo.name));
      findnext(fileinfo);
    end;
  getuniqfile := groupdir+'\'+itoa(result+1);
end;

function getuniqfext;

var
  result: integer;
  fileinfo: searchrec;
  filefound: string;
  mangledbasename: string;

begin
  result := 0;
  mangledbasename := basename;

{avoid problems when keeping outbox copy for mail to foo@prn.com etc.}

  if isdev(mangledbasename) then
    begin
      mangledbasename := basename+'_';

{some device names are 8 chars, and just adding a `_' won't help}

      if isdev(mangledbasename) then
        mangledbasename := copy(basename,1,length(basename)-1)+'_';
    end;

  findfirst(mangledbasename+'.*',archive,fileinfo);
  while doserror=0 do
    begin
      filefound := fileinfo.name;
      while pos('.',filefound)>0 do
        filefound := copy(filefound,pos('.',filefound)+1,255);
      result := max(result,atoi(filefound));
      findnext(fileinfo);
    end;
  getuniqfext := mangledbasename+'.'+itoa(result+1);
end;

function expand;

var
  work: string;
  i,j: integer;

begin
  if pos(^I,str)=0 then
    expand := str
  else
    begin
      work := '';
      for i := 1 to length(str) do
        if length(work)<240 then
          if str[i]=^I then
            for j := 1 to 8-(length(work) and 7) do
              work := work+' '
          else
            work := work+str[i];
      expand := work;
    end;
end;

function isdev;

var
  offs: word;
  segm: word;
  oldsegm: word;
  foundnul: boolean;
  result: boolean;
  basename: string;
  i: integer;

begin
  result := false;
  segm := 0;
  offs := $400;

  basename := upper(unslash(s));

{handle LPT1: case}
  if copy(basename,length(basename),1)=':' then
    basename := copy(basename,1,length(basename)-1);

{strip disk and path designators}
  while pos(':',basename)<>0 do
    basename := copy(basename,pos(':',basename)+1,255);
  while pos('\',basename)<>0 do
    basename := copy(basename,pos('\',basename)+1,255);

{strip anything after the first period}
  if pos('.',basename)<>0 then
    basename := copy(basename,1,pos('.',basename)-1);

{NUL is supposed to be guaranteed the first in the chain}
  foundnul := false;
  while (not foundnul) and (offs>0) do
    begin
      if (mem[segm:offs]=ord('N')) and
       (mem[segm:offs+1]=ord('U')) and
       (mem[segm:offs+2]=ord('L')) and
       (mem[segm:offs+3]=ord(' ')) and
       (mem[segm:offs+4]=ord(' ')) and
       (mem[segm:offs+5]=ord(' ')) and
       (mem[segm:offs+6]=ord(' ')) and
       (mem[segm:offs+7]=ord(' ')) then
        begin

{$ifdef devverbose}
          writeln('found NUL at ',offs);
          writeln('attrib=',memw[segm:offs-6]);
{$endif}

          if memw[segm:offs-6]=$8004 then
            begin

{$ifdef devverbose}
              writeln('looks like the real NUL to me!');
{$endif}

              foundnul := true;
            end;
        end;

      if not foundnul then
        inc(offs);
    end;

  if foundnul then
    begin

      while length(basename)<8 do
        basename := basename+' ';

      while not result and (meml[segm:offs-10]<>$ffffffff) do
        begin

          result := true;
          for i := 0 to 7 do
            result := result and (chr(mem[segm:offs+i])=basename[1+i]);

{$ifdef devverbose}
          writeln('name of device=',
           chr(mem[segm:offs]),
           chr(mem[segm:offs+1]),
           chr(mem[segm:offs+2]),
           chr(mem[segm:offs+3]),
           chr(mem[segm:offs+4]),
           chr(mem[segm:offs+5]),
           chr(mem[segm:offs+6]),
           chr(mem[segm:offs+7]),
           '.');

          writeln('new position: ',memw[segm:offs-10],':',memw[segm:offs-8]);
{$endif}

          oldsegm := segm;
          segm := memw[oldsegm:offs-8];
          offs := memw[oldsegm:offs-10]+10;

        end;

    end;
  isdev := result;
end;

function rot13;

var
  result: string;
  upc: char;
  i: integer;

begin
  result := s;
  for i := 1 to length(result) do
    begin
      upc := upcase(result[i]);
      if (upc>='A') and (upc<='M') then
        result[i] := chr(ord(result[i])+13)
      else if (upc>='N') and (upc<='Z') then
        result[i] := chr(ord(result[i])-13);
    end;
  rot13 := result;
end;

function indir;

var
  fileinfo: searchrec;

begin
  findfirst(dir+'\'+filespec,archive,fileinfo);
  indir := (doserror=0);
end;

function default;

begin
  if possiblyemptystr='' then
    default := defaultstr
  else
    default := possiblyemptystr;
end;

function rposc;

var
  result: integer;
  i: integer;

begin
  result := 0;
  for i := 1 to length(s) do
    if s[i]=c then
      result := i;
  rposc := result;
end;

function fexists;

var
  f: text;
  result: boolean;

begin
  result := false;
  assign(f,fn);
{$I-}
  reset(f);
{$I+}
  if ioresult=0 then
    begin
      close(f);
      result := true;
    end;
  fexists := result;
end;

function withbackslash;  {nonempty gets terminated with backslash}

var
  result: string;

begin
  result := s;
  if result<>'' then
    if result[length(result)]<>'\' then
      result := result+'\';
  withbackslash := result;
end;

function nobeep;

var
  result: string;

begin
  result := crepl(s,chr(7),'^');
  nobeep := result;
end;

function gettag;

var
  result: string;

begin
  result := '';
  if pos(tag,s)<>0 then
    begin
      result := copy(s,pos(tag,s)+length(tag),255);
      result := getquoted(result);
    end;
  gettag := result;
end;

end.
